// Copyright 2003 Regents of the University of California

// SETI_BOINC is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.

// SETI_BOINC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.

// You should have received a copy of the GNU General Public License along
// with SETI_BOINC; see the file COPYING.  If not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// In addition, as a special exception, the Regents of the University of
// California give permission to link the code of this program with libraries
// that provide specific optimized fast Fourier transform (FFT) functions and
// distribute a linked executable.  You must obey the GNU General Public 
// License in all respects for all of the code used other than the FFT library
// itself.  Any modification required to support these libraries must be
// distributed in source code form.  If you modify this file, you may extend 
// this exception to your version of the file, but you are not obligated to 
// do so. If you do not wish to do so, delete this exception statement from 
// your version.

/* config.h.  Generated by configure.  */

#ifndef _SAH_WIN_CONFIG_H_
#define _SAH_WIN_CONFIG_H_

#include "boinc_win.h"


#ifndef AP_CLIENT
#ifdef __MINGW32__
#include "seti_boinc_private.h"
#elif defined(_MSC_VER) 
#include "win_build/seti_boinc_private.h"
#endif
#endif

#ifdef _MSC_VER
#define HAVE_INTRIN_H 1
#else
#define HAVE_IMMINTRIN_H 1
#define HAVE_PMMINTRIN_H 1
#endif
#define HAVE_XMMINTRIN_H 1
#define HAVE_EMMINTRIN_H 1
#define USE_INTRINSICS 1
#define USE_SSE  1
#define USE_SSE2 1
#define USE_SSE3 1
#define USE_AVX  1

/* Define to 1 if you have the _aligned_malloc() function */
#ifdef _MSC_VER
#define HAVE__ALIGNED_MALLOC 1
#endif

/* Define to the typecast required for arg 2 of _mm256_maskstore_ps() */
// TODO: Simply this mess.  Should only need 1 #if and an #else
#if defined(_MSC_VER)
#define AVX_MASKSTORE_TYPECAST(x) static_cast<__m256i>(x)
#elif (__GNUC__ > 4) || ((__GNUC__ == 4) && (__GNUC_MINOR__ > 5) \
   || ((__GNUC__ == 4) && (__GNUC_MINOR__ == 5) && (__GNUC_PATCHLEVEL__ > 2)) \
   || ((__GNUC__ == 4) && (__GNUC_MINOR__ == 4) && (__GNUC_PATCHLEVEL__ > 5)))
#define AVX_MASKSTORE_TYPECAST(x) static_cast<__m256i>(x)
#elif defined(__GNUC__)
#define AVX_MASKSTORE_TYPECAST(x) static_cast<__m256>(x)
#else
#define AVX_MASKSTORE_TYPECAST(x) static_cast<__m256i>(x)
#endif 

// Deactivate AVX when it's definitely not supported.
#if defined(__GNUC__) && ( \
    (__GNUC__ < 4) || ((__GNUC__ == 4) && (__GNUC_MINOR__ < 4)))
#undef USE_AVX
#undef HAVE_IMMINTRIN_H
#endif
    
/* Define to 1 if you have the alloca() function */
#define HAVE_ALLOCA 1

/* Define to 1 if you have the atanf() function */
#define HAVE_ATANF 1

/* Define to 1 if you have the `atexit' function. */
#define HAVE_ATEXIT 1

/* Define to 1 if you have the `atoll' function. */
#ifdef __MINGW32__
#define HAVE_ATOLL 1
#endif

/* Define to 1 if the system has the type `bool'. */
#define HAVE_BOOL 1

/* Define to 1 if you have the cosf() function */
#define HAVE_COSF 1

/* Define to 1 if you have the <dirent.h> header file. */
/* #define HAVE_DIRENT_H 1 */

/* Define to 1 if you have the <fcntl.h> header file. */
#define HAVE_FCNTL_H 1

/* Define to 1 if you have the `floor' function. */
#define HAVE_FLOOR 1

/* Define to 1 if you have the `fork' function. */
//#define HAVE_FORK 1

/* Define to 1 if you have the `getcwd' function. */
#define HAVE_GETCWD 1

/* Define to 1 if you have the <GLUT/glut.h> header file. */
#define HAVE_GLUT_GLUT_H 1

/* Define to 1 if you have the <glut.h> header file. */
#define HAVE_GLUT_H 1

/* Define to 1 if you have the <glu.h> header file. */
/* #undef HAVE_GLU_H */

/* Define to 1 if you have the <GL/glut.h> header file. */
/* #undef HAVE_GL_GLUT_H */

/* Define to 1 if you have the <GL/glu.h> header file. */
#define HAVE_GL_GLU_H 1

/* Define to 1 if you have the <GL/gl.h> header file. */
#define HAVE_GL_GL_H 1

/* Define to 1 if you have the <gl.h> header file. */
/* #undef HAVE_GL_H */

/* Define to 1 if you have the <inttypes.h> header file. */
/* #undef HAVE_INTTYPES_H */ 

#ifdef __MINGW32__
#define HAVE_INT32_T 1
#define HAVE_INT64_T 1
#endif

#define HAVE__ISNAN 1

/* Define to 1 if you have the `aio' library (-laio). */
//#define HAVE_LIBAIO 1

/* Define to 1 if you have the `dl' library (-ldl). */
//#define HAVE_LIBDL 1

/* Define to 1 if you have the `elf' library (-lelf). */
//#define HAVE_LIBELF 1

/* Define to 1 if you have the `fftw' library (-lfftw). */
#define HAVE_LIBFFTW 1

/* Define to 1 if you have the `GL' library (-lGL). */
#define HAVE_LIBGL 1

/* Define to 1 if you have the `ICE' library (-lICE). */
//#define HAVE_LIBICE 1

/* Define to 1 if you have the `m' library (-lm). */
#define HAVE_LIBM 1

/* Define to 1 if you have the `nsl' library (-lnsl). */
//#define HAVE_LIBNSL 1

/* Define to 1 if you have the `rsaeuro' library (-lrsaeuro). */
/* #undef HAVE_LIBRSAEURO */

/* Define to 1 if you have the `s4' library (-ls4). */
/* #undef HAVE_LIBS4 */

/* Define to 1 if you have the `SM' library (-lSM). */
//#define HAVE_LIBSM 1

/* Define to 1 if you have the `socket' library (-lsocket). */
//#define HAVE_LIBSOCKET 1

/* Define to 1 if you have the `stdc++' library (-lstdc++). */
//#define HAVE_LIBSTDC__ 1

/* Define to 1 if you have the `X11' library (-lX11). */
//#define HAVE_LIBX11 1

/* Define to 1 if you have the `Xaw' library (-lXaw). */
//#define HAVE_LIBXAW 1

/* Define to 1 if you have the `Xext' library (-lXext). */
//#define HAVE_LIBXEXT 1

/* Define to 1 if you have the `Xmu' library (-lXmu). */
//#define HAVE_LIBXMU 1

/* Define to 1 if you have the `Xt' library (-lXt). */
/* #define HAVE_LIBXT 1 */

/* Define to 1 if you have the `z' library (-lz). */
/* #define HAVE_LIBZ 1 */

/* Define to 1 if you have the <limits.h> header file. */
#define HAVE_LIMITS_H 1

/* Define to 1 if long double works and has more range or precision than
   double. */
#define HAVE_LONG_DOUBLE 1

/* Define to 1 if the system has the type `long long'. */
#ifdef __MINGW32__
#define HAVE_LONG_LONG 1
#endif

/* Define to 1 if your system has a GNU libc compatible `malloc' function, and
   to 0 otherwise. */
#define HAVE_MALLOC 1

/* Define to 1 if you have the <malloc.h> header file. */
#define HAVE_MALLOC_H 1

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* Define to 1 if you have the `memset' function. */
#define HAVE_MEMSET 1

/* Define to 1 if you have the `munmap' function. */
/* #define HAVE_MUNMAP 1 */

/* Define if your C++ compiler supports namespaces */
#define HAVE_NAMESPACES 1

/* Define to 1 if you have the <OpenGL/glut.h> header file. */
/* #undef HAVE_OPENGL_GLUT_H */

/* Define to 1 if you have the <OpenGL/glu.h> header file. */
/* #undef HAVE_OPENGL_GLU_H */

/* Define to 1 if you have the <OpenGL/gl.h> header file. */
/* #undef HAVE_OPENGL_GL_H */

/* Define to 1 if you have the `putenv' function. */
#define HAVE_PUTENV 1

/* Define to 1 if your system has a GNU libc compatible `realloc' function,
   and to 0 otherwise. */
#define HAVE_REALLOC 1

/* Define to 1 if you have the sinf() function */
#define HAVE_SINF 1

/* Define to 1 if you have the sincosf() function */
/* #undef HAVE_SINCOSF */

/* Define to 1 if you have the `sqrt' function. */
#define HAVE_SQRT 1

/* Define to 1 if `stat' has the bug that it succeeds when given the
   zero-length file name argument. */
/* #undef HAVE_STAT_EMPTY_STRING_BUG */

#if ( _MSC_VER > 1300 )  || defined(__MINGW32__)
  /* Define to 1 if the max template is in namespace std. */
  #define HAVE_STD_MAX 1

  /* Define to 1 if the min template is in namespace std. */
  #define HAVE_STD_MIN 1
#endif

/* Define to 1 if the transform template is in namespace std. */
#define HAVE_STD_TRANSFORM 1

/* Define to 1 if stdbool.h conforms to C99. */
/* #undef HAVE_STDBOOL_H */

/* Define to 1 if you have the <stdint.h> header file. */
#ifdef __MINGW32__
#define HAVE_STDINT_H 1
#endif

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

#ifdef __MINGW32__
#define HAVE_STRCASECMP 1
#endif

/* Define to 1 if you have the `strchr' function. */
#define HAVE_STRCHR 1

/* Define to 1 if you have the `strftime' function. */
#define HAVE_STRFTIME 1

/* Define to 1 if you have the <strings.h> header file. */
/* #define HAVE_STRINGS_H 1 */

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the `strstr' function. */
#define HAVE_STRSTR 1

/* Define to 1 if `st_blocks' is member of `struct stat'. */
/* #define HAVE_STRUCT_STAT_ST_BLOCKS 1 */

/* Define to 1 if your `struct stat' has `st_blocks'. Deprecated, use
   `HAVE_STRUCT_STAT_ST_BLOCKS' instead. */
/* #define HAVE_ST_BLOCKS 1 */

/* Define to 1 if you have the <sys/ioctl.h> header file. */
/* #define HAVE_SYS_IOCTL_H 1 */

/* Define to 1 if you have the <sys/statvfs.h> header file. */
/* #define HAVE_SYS_STATVFS_H 1 */

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/time.h> header file. */
/* #undef HAVE_SYS_TIME_H */

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have <sys/wait.h> that is POSIX.1 compatible. */
/* #define HAVE_SYS_WAIT_H 1 */

/* Define to 1 if you have the <unistd.h> header file. */
/* #define HAVE_UNISTD_H 1 */

/* Define to 1 if you have the `vfork' function. */
/* #define HAVE_VFORK 1

/* Define to 1 if you have the <vfork.h> header file. */
/* #undef HAVE_VFORK_H */

/* Define to 1 if `fork' works. */
/* #define HAVE_WORKING_FORK 1 */

/* Define to 1 if `vfork' works. */
/* #define HAVE_WORKING_VFORK 1 */

/* Define to 1 if the system has the type `_Bool'. */
/* #undef HAVE__BOOL */

#ifndef __MINGW32__

/* Define to 1 if the system has the type `_int32'. */
#define HAVE__INT32 1

/* Define to 1 if the system has the type `_int64'. */
#define HAVE__INT64 1

#endif

/* Define to 1 if `lstat' dereferences a symlink specified with a trailing
   slash. */
/* #undef LSTAT_FOLLOWS_SLASHED_SYMLINK */

/* Define to 1 if `major', `minor', and `makedev' are declared in <mkdev.h>.
   */
#define MAJOR_IN_MKDEV 1

/* Define to 1 if `major', `minor', and `makedev' are declared in
   <sysmacros.h>. */
/* #undef MAJOR_IN_SYSMACROS */

/* Define for custom build identification in stderr */

/* Define to the address where bug reports for this package should be sent. */
#undef PACKAGE_BUGREPORT
#define PACKAGE_BUGREPORT "korpela@ssl.berkeley.edu"

/* Define to the full name of this package. */
#undef PACKAGE_NAME
#define PACKAGE_NAME FILE_DESCRIPTION

/* Define to the full name and version of this package. */
#undef PACKAGE_STRING
#define PACKAGE_STRING FILE_DESCRIPTION" "FILE_VERSION

/* Define to the one symbol short name of this package. */
#undef PACKAGE_TARNAME
#define PACKAGE_TARNAME FILE_DESCRIPTION

/* Define to the version of this package. */
#undef PACKAGE_VERSION
#define PACKAGE_VERSION FILE_VERSION

#ifndef COMPILER_STRING
#ifdef __MINGW32__
#define QUOTEME_(x) #x
#define QUOTEME(x) QUOTEME_(x)
#define COMPILER_STRING "DevC++/MinGW/g++ "\
                        QUOTEME(__GNUC__) "."\
                        QUOTEME(__GNUC_MINOR__) "."\
                        QUOTEME(__GNUC_PATCHLEVEL__)
#elif defined(_MSC_VER)
#define COMPILER_STRING "Visual Studio 2005/Microsoft Visual C++ 8"
#else 
#define COMPILER_STRING "Unknown Compiler"
#endif
#endif

#ifndef CUSTOM_STRING
#define CUSTOM_STRING "setiathome_v7 "FILE_VERSION" "COMPILER_STRING
#endif

/* The size of a `long double', as computed by sizeof. */
#define SIZEOF_LONG_DOUBLE sizeof (long double)

/* The size of a `long int', as computed by sizeof. */
#define SIZEOF_LONG_INT 4

/* Define to 1 if you have the ANSI C header files. */
#define STDC_HEADERS 1

/* Define to 1 if your <sys/time.h> declares `struct tm'. */
/* #undef TM_IN_SYS_TIME */

/* Define to 1 if informix is installed */
/* #undef USE_INFORMIX */

/* Define if MYSQL is installed */
/* #undef USE_MYSQL */

/* SETI@home major version number */
#define VERSION_MAJOR VER_MAJOR

/* SETI@home minor version number */
#define VERSION_MINOR VER_MINOR

/* Define to empty if `const' does not conform to ANSI C. */
/* #undef const */

/* Define as `__inline' if that's what the C compiler calls it, or to nothing
   if it is not supported. */
#ifdef _MSC_VER
#undef inline
typedef ptrdiff_t ssize_t;
#endif

/* Define to rpl_malloc if the replacement function should be used. */
/* #undef malloc */

/* Define to `long' if <sys/types.h> does not define. */
/* #undef off_t */

/* Define to `int' if <sys/types.h> does not define. */
/* #undef pid_t */

/* Define to rpl_realloc if the replacement function should be used. */
/* #undef realloc */

/* Define to `unsigned' if <sys/types.h> does not define. */
/* #undef size_t */

/* Define as `fork' if `vfork' does not work. */
/* #undef vfork */

#if defined(HAVE_LIBFFTW)
#define USE_FFTWF
#endif

#if defined(USE_INFORMIX) && defined(USE_MYSQL) && defined(HAVE_NAMESPACES)
#define USE_NAMESPACES
#endif

#endif
